/************************************************************************
 * This program is Copyright (C) 1986-1996 by Jonathan Payne.  JOVE is  *
 * provided to you without charge, and with no warranty.  You may give  *
 * away copies of JOVE, including sources, provided that this notice is *
 * included in all the files.                                           *
 ************************************************************************/

/* This file is #included by vars.c and setmaps.c */

const struct variable	variables[] = {
	{ VARIABLE, "abort-char", VAR(&AbortChar), V_CHAR },
#ifdef UNIX
	{ VARIABLE, "allow-^S-and-^Q", VAR(&OKXonXoff), V_BOOL|V_TTY_RESET },
#endif
	{ VARIABLE, "allow-bad-characters-in-filenames", VAR(&OkayBadChars), V_BOOL },
	{ VARIABLE, "allow-bad-filenames", VAR(&OkayBadChars), V_BOOL },	/* obsolete */
#ifdef ABBREV
	{ VARIABLE, "auto-case-abbrev", VAR(&AutoCaseAbbrev), V_BOOL },
#endif
#ifdef F_COMPLETION
	{ VARIABLE, "bad-filename-extensions", VAR(BadExtensions), V_STRING },
#endif
	{ VARIABLE, "c-argument-indentation", VAR(&CArgIndent), V_WHOLEX },
	{ VARIABLE, "c-indentation-increment", VAR(&CIndIncrmt), V_WHOLE },
	{ VARIABLE, "case-ignore-search", VAR(&CaseIgnore), V_BOOL },
#ifdef CMT_FMT
	{ VARIABLE, "comment-format", VAR(CmtFmt), V_STRING },
#endif
#ifdef IPROCS
	{ VARIABLE, "dbx-format-string", VAR(dbx_parse_fmt), V_STRING },
#endif
#ifdef BIFF
	{ VARIABLE, "disable-biff", VAR(&DisBiff), V_BOOL|V_TTY_RESET },
#endif
#ifdef F_COMPLETION
	{ VARIABLE, "display-bad-filenames", VAR(&DispBadFs), V_BOOL },	/* obsolete */
	{ VARIABLE, "display-filenames-with-bad-extensions", VAR(&DispBadFs), V_BOOL },
#endif
#ifdef IBMPCDOS
	{ VARIABLE, "enhanced-keyboard", VAR(&enhanced_keybrd), V_BOOL },
#endif
	{ VARIABLE, "error-format-string", VAR(ErrFmtStr), V_STRING },
	{ VARIABLE, "error-window-size", VAR(&EWSize), V_NAT },
#ifdef F_COMPLETION
# ifndef MAC	/* no environment in MacOS */
	{ VARIABLE, "expand-environment-variables", VAR(&DoEVexpand), V_BOOL },
# endif
#endif
#ifdef UNIX
	{ VARIABLE, "file-creation-mode", VAR(&CreatMode), V_WHOLE|V_FMODE },
#endif
	{ VARIABLE, "files-should-end-with-newline", VAR(&EndWNewline), V_BOOL },
#ifdef HIGHLIGHTING
# ifdef PCSCRATTR
	{ VARIABLE, "highlight-attribute", VAR(&Hlattr), V_WHOLE|V_CLRSCREEN },
# endif
	{ VARIABLE, "highlight-mark", VAR(&MarkHighlighting), V_BOOL|V_CLRSCREEN },
#endif	/* HIGHLIGHTING */
	{ VARIABLE, "internal-tabstop", VAR(&tabstop), V_NAT|V_CLRSCREEN },	/* obsolete */
#ifdef UNIX
	{ VARIABLE, "interrupt-character", VAR(&IntChar), V_CHAR|V_TTY_RESET },
#endif
#if defined(USE_CTYPE) && !defined(NO_SETLOCALE)
	{ VARIABLE, "lc-ctype", VAR(LcCtype), V_STRING|V_LOCALE },
#endif
	{ VARIABLE, "left-margin", VAR(&LMargin), V_WHOLE },
#ifdef MAC
	{ VARIABLE, "macify", VAR(&Macmode), V_BOOL },
#endif
#ifdef UNIX
	{ VARIABLE, "mail-check-frequency", VAR(&MailInt), V_WHOLE },
	{ VARIABLE, "mailbox", VAR(Mailbox), V_FILENAME },
#endif /* UNIX */
#ifdef BACKUPFILES
	{ VARIABLE, "make-backup-files", VAR(&BkupOnWrite), V_BOOL },
#endif
	{ VARIABLE, "mark-threshold", VAR(&MarkThresh), V_WHOLEX },
	{ VARIABLE, "match-regular-expressions", VAR(&UseRE), V_BOOL },
	{ VARIABLE, "meta-key", VAR(&MetaKey), V_BOOL|V_TTY_RESET },
	{ VARIABLE, "mode-line", VAR(ModeFmt), V_STRING|V_MODELINE },
#ifdef PCSCRATTR
	{ VARIABLE, "mode-line-attribute", VAR(&Mlattr), V_WHOLE|V_CLRSCREEN },
#endif
	{ VARIABLE, "mode-line-should-standout", VAR(&BriteMode), V_BOOL|V_MODELINE },
	{ VARIABLE, "one-key-confirmation", VAR(&OneKeyConfirmation), V_BOOL },
	{ VARIABLE, "paragraph-delimiter-pattern", VAR(ParaDelim), V_STRING },
	{ VARIABLE, "paren-flash-delay", VAR(&PDelay), V_WHOLE },
#ifdef IPROCS
	{ VARIABLE, "process-prompt", VAR(proc_prompt), V_STRING },
#endif
	{ VARIABLE, "right-margin", VAR(&RMargin), V_NAT },
	{ VARIABLE, "scroll-all-lines", VAR(&ScrollAll), V_BOOL },
#ifdef HIGHLIGHTING
	{ VARIABLE, "scroll-bar", VAR(&ScrollBar), V_BOOL|V_MODELINE },
#endif
	{ VARIABLE, "scroll-step", VAR(&ScrollStep), V_INT },
	{ VARIABLE, "scroll-width", VAR(&ScrollWidth), V_WHOLE },
	{ VARIABLE, "search-exit-char", VAR(&SExitChar), V_CHAR },
	{ VARIABLE, "send-typeout-to-buffer", VAR(&UseBuffers), V_BOOL },
#ifdef SUBSHELL
	{ VARIABLE, "shell", VAR(Shell), V_FILENAME },
	{ VARIABLE, "shell-flags", VAR(ShFlags), V_STRING },
#endif
	{ VARIABLE, "space-sentence-2", VAR(&SpaceSent2), V_BOOL },
#ifdef RECOVER
	{ VARIABLE, "sync-frequency", VAR(&SyncFreq), V_WHOLE },
#endif
	{ VARIABLE, "tab-width", VAR(&tabstop), V_WHOLE|V_CLRSCREEN },
	{ VARIABLE, "tag-file", VAR(TagFile), V_FILENAME },
#ifdef PCSCRATTR
	{ VARIABLE, "text-attribute", VAR(&Txattr), V_WHOLE|V_CLRSCREEN },
#endif
	{ VARIABLE, "tmp-file-pathname", VAR(TmpDir), V_FILENAME },
#ifdef UNIX
	{ VARIABLE, "update-time-frequency", VAR(&UpdFreq), V_WHOLE|V_UPDFREQ },
#endif
#ifdef ID_CHAR
	{ VARIABLE, "use-i/d-char", VAR(&UseIC), V_BOOL },
#endif
	{ VARIABLE, "visible-bell", VAR(&VisBell), V_BOOL },
#if defined(SUBSHELL) || defined(IPROCS)
	{ VARIABLE, "wrap-process-lines", VAR(&WrapProcessLines), V_BOOL },
#endif
	{ VARIABLE, "wrap-search", VAR(&WrapScan), V_BOOL },
#ifdef SUBSHELL
	{ VARIABLE, "write-files-on-make", VAR(&WtOnMk), V_BOOL },
#endif
#ifdef MOUSE
	{ VARIABLE, "xt-mouse", VAR(&XtermMouse), V_BOOL|V_TTY_RESET },
#endif
	{ VARIABLE, NULL, NULL, (size_t)0, 0 },
};
